//+------------------------------------------------------------------+
//|                                                 BrainTrendEA.mq4 |
//|          Copyright  2006, firedave base on dreamer trading plan | 
//|                    Partial Function Copyright  2006, codersguru | 
//|                        Partial Function Copyright  2006, pengie | 
//|                                        http://www.fx-review.com/ | 
//|                                        http://www.forex-tsd.com/ | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, firedave"
#property link      "http://www.fx-review.com"

//+------------------------------------------------------------------+
//| INCLUDES FILES                                                   |
//+------------------------------------------------------------------+
#include <stdlib.mqh>

//+------------------------------------------------------------------+
//| EXPERT ADVISOR EXTERN VARIABLE                                   |
//+------------------------------------------------------------------+
extern string  
         Expert_Name       = "---------- Silver Trend2 EA v1";
extern double 
         StopLoss          = 0,
         TakeProfit        = 0,
         TrailingStop      = 0;

extern string  
         Indicator_Setting = "---------- Indicator Setting",
         IndicatorName1     = "SilverTrend_Signal";
extern int
         NumBars           = 500,
         IndicatorRisk     = 3;
          
extern string  
         Order_Setting     = "---------- Order Setting";
extern int
         MagicNumber       = 1234,
         NumberOfTries     = 5,
         Slippage          = 5;
extern bool
         UseNewBar         = true,
         StopAndReverse    = true;

extern string  
         Time_Parameters    = "---------- EA Active Time";
extern bool    
         UseHourTrade      = false;
extern int     
         StartHour         = 9,
         EndHour           = 23;
         
extern string  
         MM_Parameters     = "---------- Money Management";
extern double 
         Lots              = 1;
extern bool 
         MM                = false,
         AccountIsMicro    = false;
extern int 
         Risk              = 5;

//+------------------------------------------------------------------+
//| EXPERT ADVISOR PROGRAM SETTING AND GLOBAL VARIABLES              |
//+------------------------------------------------------------------+
bool
         GenerateMagicN    = true;
string
         TimeFilterOn      = "ALL",
         TicketComment     = "SilverTrendv1",
         LastTrade;         
static int
         TimeFrame         = 0;
datetime
         CheckTime;

//+------------------------------------------------------------------+
//| EXPERT ADVISOR ADDITIONAL GLOBAL VARIABLES                       |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| INITIALIZATION FUNCTION                                          |
//+------------------------------------------------------------------+
int init()
{

//+------------------------------------------------------------------+
//| BUILD MAGIC NUMBER AND TICKET COMMENT
//+------------------------------------------------------------------+
   if(GenerateMagicN)
   {
      MagicNumber    = subGenerateMagicNumber(MagicNumber, Symbol(), Period());
      TicketComment  = StringConcatenate(TicketComment, "-", Symbol(), "-", Period());
      return(0);
   }
}

//+------------------------------------------------------------------+
//| DE-INITIALIZATION FUNCTION                                       |
//+------------------------------------------------------------------+
int deinit()
{
 
//+------------------------------------------------------------------+
//| PREVENT RE-COUNTING WHILE USER CHANGING TIME FRAME               |
//+------------------------------------------------------------------+
   TimeFrame=Period(); 
   return(0);
}


//+------------------------------------------------------------------+
//| EXPERT ADVISOR START                                             |
//+------------------------------------------------------------------+
int start()
{

//+------------------------------------------------------------------+
//| EXPERT ADVISOR LOCAL VARIABLES                                   |
//+------------------------------------------------------------------+
   double 
         BuyValueCurrent,
         SellValueCurrent;
   int   
         cnt,
         ticket,
         total;
   bool
         BuyCondition,
         SellCondition;
         
//+------------------------------------------------------------------+
//| CHECK CHART NEED MORE THAN 100 BARS                              |
//+------------------------------------------------------------------+
   if(Bars<100)
   {
      Print("bars less than 100");
      return(0);  
   }

//+------------------------------------------------------------------+
//| TIME FILTER ON ALL EA ACTIVITY                                   |
//+------------------------------------------------------------------+
   if (TimeFilterOn=="ALL" && UseHourTrade)
   {
      if(!(Hour()>=StartHour && Hour()<=EndHour))
      {
         Comment("Non-Trading Hours!");
         return(0);
      }
   }

//+------------------------------------------------------------------+
//| MAINTAIN ANY OPEN TRADE                                          |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| EXIT CONDITION (IF DIFFERENT THAN ENTRRY CONDITION)              |
//| n/a                                                              |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| TRAILING STOP                                                    |
//+------------------------------------------------------------------+
   if(subTotalTrade()>0 && TrailingStop>0)
   {
      total = OrdersTotal();
      for(cnt=0;cnt<total;cnt++)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

         if(OrderType()<=OP_SELL &&
            OrderSymbol()==Symbol() &&
            OrderMagicNumber()==MagicNumber)
         {
            subTrailingStop(OrderType());
         }
      }
   }                  

//+------------------------------------------------------------------+
//| CHECK FOR NEW BAR                                                |
//+------------------------------------------------------------------+
   if(UseNewBar)
   {
      if(CheckTime==iTime(NULL,TimeFrame,0)) return(0); else CheckTime = iTime(NULL,TimeFrame,0);

//+------------------------------------------------------------------+
//| GET VALUE FROM INDICATORS                                        |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| IF USING NEW BAR CONFIRMATION                                    |
//+------------------------------------------------------------------+
      BuyValueCurrent   = iCustom(NULL,TimeFrame,IndicatorName1,Risk,NumBars,0,1);
      SellValueCurrent  = iCustom(NULL,TimeFrame,IndicatorName1,Risk,NumBars,1,1);
   }
   else
//+------------------------------------------------------------------+
//| IF NOT USING NEW BAR CONFIRMATION (USE CURRENT BAR VALUE)        |
//+------------------------------------------------------------------+
   {
      BuyValueCurrent   = iCustom(NULL,TimeFrame,IndicatorName1,Risk,NumBars,0,0);
      SellValueCurrent  = iCustom(NULL,TimeFrame,IndicatorName1,Risk,NumBars,1,0);
   }
      
//+------------------------------------------------------------------+
//| ENTRY CONDITION                                                  |
//+------------------------------------------------------------------+
   BuyCondition  = (BuyValueCurrent >0);
   SellCondition = (SellValueCurrent>0);
      
//+------------------------------------------------------------------+
//| STOP AND REVERSE                                                 |
//+------------------------------------------------------------------+
   if(StopAndReverse && subTotalTrade()>0)
   {
      if((LastTrade=="BUY" && SellCondition) ||
         (LastTrade=="SELL" && BuyCondition)) 
      {
         subCloseOrder();
      }            
   }      

//+------------------------------------------------------------------+
//| ADJUST LOTS IF USING MONEY MANAGEMENT                            |
//+------------------------------------------------------------------+
   if(MM) Lots = subLotSize();

//+------------------------------------------------------------------+
//| NEW TRADE - ENTRY                                                |
//+------------------------------------------------------------------+
   if(subTotalTrade()<1 && (BuyCondition || SellCondition)) 
   {

//+------------------------------------------------------------------+
//| TIME FILTER ON ENTRY                                             |
//+------------------------------------------------------------------+
      if(TimeFilterOn=="ENTRY" && UseHourTrade &&
         (Hour()<StartHour || Hour()>EndHour))
      {
         return(0);
      }

//+------------------------------------------------------------------+
//| OPEN BUY ORDER                                                   |
//+------------------------------------------------------------------+
      if(BuyCondition)
      {
         ticket        = subOpenOrder(OP_BUY,StopLoss,TakeProfit,TicketComment);
         subCheckError(ticket,"BUY");
         LastTrade     = "BUY";
         return(0);
      }

//+------------------------------------------------------------------+
//| OPEN SELL ORDER                                                  |
//+------------------------------------------------------------------+
      if(SellCondition)
      {
         ticket        = subOpenOrder(OP_SELL,StopLoss,TakeProfit,TicketComment);
         subCheckError(ticket,"SELL");
         LastTrade     = "SELL";
         return(0);
      }
   }

//+------------------------------------------------------------------+
//| IF THERE IS NOTHING ELSE GO TO START                             |
//+------------------------------------------------------------------+
   return(0);
}

//+------------------------------------------------------------------+
//| END PROGRAM                                                      |
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| FUNCTION DEFINITIONS                                             |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| FUNCTION : MONEY MANAGEMENT                                      |
//| SOURCE   : CODERSGURU                                            |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
double subLotSize()
{
     double lotMM = MathCeil(AccountFreeMargin() *  Risk / 1000) / 100;
	  
	  if(AccountIsMicro==false) //normal account
	  {
	     if(lotMM < 0.1)                  lotMM = Lots;
	     if((lotMM > 0.5) && (lotMM < 1)) lotMM = 0.5;
	     if(lotMM > 1.0)                  lotMM = MathCeil(lotMM);
	     if(lotMM > 100)                  lotMM = 100;
	  }
	  else //micro account
	  {
	     if(lotMM < 0.01)                 lotMM = Lots;
	     if(lotMM > 1.0)                  lotMM = MathCeil(lotMM);
	     if(lotMM > 100)                  lotMM = 100;
	  }
	  
	  return (lotMM);
}

//+------------------------------------------------------------------+
//| FUNCTION : NUMBER OF ORDER BASE ON SYMBOL AND MAGIC NUMBER       |
//| SOURCE   : n/a                                                   |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
int subTotalTrade()
{
   int
      cnt, 
      total = 0;

   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL &&
         OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber) total++;
   }
   return(total);
}

//+------------------------------------------------------------------+
//| FUNCTION : OPEN ORDER                                            |
//| SOURCE   : CODERSGURU, PENGIE                                    |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
int subOpenOrder(int type, int mStopLoss, int mTakeProfit, string mTicketComment)
{
   int
         ticket      = 0,
         err         = 0,
         c           = 0;
         
   double         
         aStopLoss   = 0,
         aTakeProfit = 0,
         bStopLoss   = 0,
         bTakeProfit = 0;

   if(mStopLoss!=0)
   {
      aStopLoss   = Ask-mStopLoss*Point;
      bStopLoss   = Bid+mStopLoss*Point;
   }
   
   if(mTakeProfit!=0)
   {
      aTakeProfit = Ask+mTakeProfit*Point;
      bTakeProfit = Bid-mTakeProfit*Point;
   }
   
   if(type==OP_BUY)
   {
      for(c=0;c<NumberOfTries;c++)
      {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,aStopLoss,aTakeProfit,mTicketComment,MagicNumber,0,Green);
         err=GetLastError();
         if(err==0)
         { 
            break;
         }
         else
         {
            if(err==4 || err==137 ||err==146 || err==136) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               break;
            }  
         }
      }   
   }
   if(type==OP_SELL)
   {   
      for(c=0;c<NumberOfTries;c++)
      {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,bStopLoss,bTakeProfit,mTicketComment,MagicNumber,0,Red);
         err=GetLastError();
         if(err==0)
         { 
            break;
         }
         else
         {
            if(err==4 || err==137 ||err==146 || err==136) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               break;
            }  
         }
      }   
   }  
   return(ticket);
}

//+------------------------------------------------------------------+
//| FUNCTION : CLOSE ORDER                                           |
//| SOURCE   : n/a                                                   |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
void subCloseOrder()
{
   int
      cnt, 
      total = 0;

   total = OrdersTotal();
   for(cnt=total-1;cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if(OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber)
      {
         switch(OrderType())
         {
            case OP_BUY      :
               OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet);
               break;
               
            case OP_SELL     :
               OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet);
               break;
         }
      }
   }      
}

//+------------------------------------------------------------------+
//| FUNCTION : TRAILING STOP                                         |
//| SOURCE   : CODERSGURU                                            |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
void subTrailingStop(int Type)
{
   if(Type==OP_BUY)   // buy position is opened   
   {
      if(Bid-OrderOpenPrice()>Point*TrailingStop &&
         OrderStopLoss()<Bid-Point*TrailingStop)
      {
         OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
         return(0);
      }
   }

   if(Type==OP_SELL)   // sell position is opened   
   {
      if(OrderOpenPrice()-Ask>Point*TrailingStop)
      {
      if(OrderStopLoss()>Ask+Point*TrailingStop || OrderStopLoss()==0)
      {
         OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
         return(0);
      }
      }
   }
}

//+------------------------------------------------------------------+
//| FUNCTION : CHECK ERROR CODE                                      |
//| SOURCE   : CODERSGURU                                            |
//| MODIFIED : n/a                                                   |
//+------------------------------------------------------------------+
void subCheckError(int ticket, string Type)
{
    if(ticket>0) 
    {
//      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print(Type + " order opened : ",OrderOpenPrice());
    }
    else Print("Error opening " + Type + " order : ", ErrorDescription(GetLastError()));
}

//+------------------------------------------------------------------+
//| FUNCTION : GENERATE MAGIC NUMBER BASE ON SYMBOL AND TIME FRAME   |
//| SOURCE   : PENGIE                                                |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
int subGenerateMagicNumber(int MagicNumber, string symbol, int timeFrame)
{
   int isymbol = 0;
   if (symbol == "EURUSD")       isymbol = 1;
   else if (symbol == "GBPUSD")  isymbol = 2;
   else if (symbol == "USDJPY")  isymbol = 3;
   else if (symbol == "USDCHF")  isymbol = 4;
   else if (symbol == "AUDUSD")  isymbol = 5;
   else if (symbol == "USDCAD")  isymbol = 6;
   else if (symbol == "EURGBP")  isymbol = 7;
   else if (symbol == "EURJPY")  isymbol = 8;
   else if (symbol == "EURCHF")  isymbol = 9;
   else if (symbol == "EURAUD")  isymbol = 10;
   else if (symbol == "EURCAD")  isymbol = 11;
   else if (symbol == "GBPUSD")  isymbol = 12;
   else if (symbol == "GBPJPY")  isymbol = 13;
   else if (symbol == "GBPCHF")  isymbol = 14;
   else if (symbol == "GBPAUD")  isymbol = 15;
   else if (symbol == "GBPCAD")  isymbol = 16;
   else                          isymbol = 17;
   if(isymbol<10) MagicNumber = MagicNumber * 10;
   return (StrToInteger(StringConcatenate(MagicNumber, isymbol, timeFrame)));
}

//+------------------------------------------------------------------+
//| END FUNCTION                                                     |
//+------------------------------------------------------------------+

